Set user DEX abstraction
curl --request POST \
--url https://api.hyperliquid.xyz/exchange \
--header 'Content-Type: application/json' \
--data '
{
"action": {
"type": "userDexAbstraction",
"hyperliquidChain": "Mainnet",
"signatureChainId": "0xa4b1",
"user": "0x1234567890abcdef1234567890abcdef12345678",
"enabled": true,
"nonce": 1705234567890
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": null
}
'import requests
url = "https://api.hyperliquid.xyz/exchange"
payload = {
"action": {
"type": "userDexAbstraction",
"hyperliquidChain": "Mainnet",
"signatureChainId": "0xa4b1",
"user": "0x1234567890abcdef1234567890abcdef12345678",
"enabled": True,
"nonce": 1705234567890
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {
type: 'userDexAbstraction',
hyperliquidChain: 'Mainnet',
signatureChainId: '0xa4b1',
user: '0x1234567890abcdef1234567890abcdef12345678',
enabled: true,
nonce: 1705234567890
},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};
fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"status": "<string>",
"response": {}
}Hyperliquid node API
userDexAbstraction | Hyperliquid exchange
Sets the user’s DEX abstraction configuration for perp DEX routing. This is being deprecated in favor of the unified account system.
POST
/
exchange
Set user DEX abstraction
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.
Parameters
Required parameters
action(object, required) — The action object containing:type(string) — Must be"userDexAbstraction"dexAbstraction(object) — DEX abstraction configuration
nonce(number, required) — Current timestamp in milliseconds (must be recent)signature(object, required) — EIP-712 signature of the action
Optional parameters
vaultAddress(string, optional) — Address when trading on behalf of a vault or subaccount
Returns
Returns an object with the action status:status—"ok"if request processedresponse— Contains action result data
Example request
curl -X POST https://api.hyperliquid.xyz/exchange \
-H "Content-Type: application/json" \
-d '{
"action": {"type": "userDexAbstraction"},
"nonce": 1234567890123,
"signature": {...}
}'
import eth_account
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants
# Load the wallet that signs the action.
wallet = eth_account.Account.from_key("YOUR_PRIVATE_KEY")
# Public Hyperliquid API (this method is public-only).
exchange = Exchange(wallet, constants.MAINNET_API_URL)
result = exchange.user_dex_abstraction(
user=wallet.address,
enabled=True,
)
print(result)
import * as hl from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";
// Wallet that signs the action (viem or ethers).
const wallet = privateKeyToAccount("0xYOUR_PRIVATE_KEY");
// Public Hyperliquid API (this method is public-only).
const transport = new hl.HttpTransport();
const client = new hl.ExchangeClient({ transport, wallet });
const result = await client.userDexAbstraction({
user: wallet.address,
enabled: true,
});
console.log(result);
Use case
- Set user DEX abstraction — Sets the user’s DEX abstraction configuration for perp DEX routing. This is being deprecated in favor of the unified account system.
Always ensure your system clock is synchronized. Nonce must be within a reasonable time window of the current server time or the request will be rejected.
Body
application/json
Last modified on June 24, 2026
Was this page helpful?
⌘I